#include "pwm.h"
#include "ets_sys.h"
#include "osapi.h"

//Array with 32-bit values which have one bit more set to '1' in every consecutive array index value
const unsigned int ICACHE_RODATA_ATTR fakePwm[]= {
    0x00000010, 0x00000410, 0x00400410, 0x00400C10,
    0x00500C10, 0x00D00C10, 0x20D00C10, 0x21D00C10,
    0x21D80C10, 0xA1D80C10, 0xA1D80D10, 0xA1D80D30,
    0xA1DC0D30, 0xA1DC8D30, 0xB1DC8D30, 0xB9DC8D30,
    0xB9FC8D30, 0xBDFC8D30, 0xBDFE8D30, 0xBDFE8D32,
    0xBDFE8D33, 0xBDFECD33, 0xFDFECD33, 0xFDFECD73,
    0xFDFEDD73, 0xFFFEDD73, 0xFFFEDD7B, 0xFFFEFD7B,
    0xFFFFFD7B, 0xFFFFFDFB, 0xFFFFFFFB, 0xFFFFFFFF
};

int sampToI2sPwm(short s) {
    //Okay, when this is enabled it means a speaker is connected *directly* to the data output. Instead of
    //having a nice PCM signal, we fake a PWM signal here.
    static int err = 0;
    int samp = s;
    samp = samp + 32768;	//to unsigned
    samp -= err;			//Add the error we made when rounding the previous sample (error diffusion)
    //clip value
    if (samp > 65535)
        samp = 65535;
    if (samp < 0)
        samp = 0;
    //send pwm value for sample value
    samp = fakePwm[samp>>11];
    err = (samp&0x7ff);	//Save rounding error.
    return samp;
}
#if 1
int sampToI2sDeltaSigma(short s) {
	int x;
	int val=0;
	int w;
	static int i1v=0, i2v=0;
	static int outReg=0;
	for (x=0; x<32; x++) {
		val<<=1; //next bit
		w=s;
		if (outReg>0) w-=32767; else w+=32767; //Difference 1
		w+=i1v; i1v=w; //Integrator 1
		if (outReg>0) w-=32767; else w+=32767; //Difference 2
		w+=i2v; i2v=w; //Integrator 2
		outReg=w;		//register
		if (w>0) val|=1; //comparator
	}
	return val;
}
#endif
